<?php


namespace Commons\Http\Resources;

use Carbon\Carbon;
use Illuminate\Http\Request;

trait ResourceMeta
{
    public $statusCode = 200;

    public $message = 'Success!';

    public function additionalMerge(array $data)
    {
        $this->additional = array_merge($this->additional ?: [], $data);
        return parent::additional($data); // TODO: Change the autogenerated stub
    }

    /**
     * @param Request $request
     * @param \Illuminate\Http\JsonResponse $response
     */
    public function withResponse($request, $response)
    {
        $data = $response->getData();
        $response->setStatusCode($this->statusCode);
        $response->setData(array_merge_recursive((array) $data, ['meta' => [
            'status_code' => $this->statusCode,
            'message' => $this->message,
        ]]));
    }

    /**
     * @param Request $request
     * @return array
     */
    public function with($request)
    {
        return [
            'meta' => [
                'timestamp' => Carbon::now()->setTimezone('Asia/Kuala_Lumpur'),
                'url' => $request->fullUrl(),
            ]
        ];
    }

}